{{/*
 * Copyright (C) 2015 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */}}

{{define "Java.Type#bool"}}boolean{{end}}
{{define "Java.Type#int8"}}byte{{end}}
{{define "Java.Type#uint8"}}byte{{end}}
{{define "Java.Type#int16"}}short{{end}}
{{define "Java.Type#uint16"}}short{{end}}
{{define "Java.Type#int32"}}int{{end}}
{{define "Java.Type#uint32"}}int{{end}}
{{define "Java.Type#int64"}}long{{end}}
{{define "Java.Type#uint64"}}long{{end}}
{{define "Java.Type#float32"}}float{{end}}
{{define "Java.Type#float64"}}double{{end}}
{{define "Java.Type#string"}}String{{end}}
{{define "Java.Type#binary.ID"}}BinaryID{{end}}
{{define "Java.Type#binary.Object"}}BinaryObject{{end}}
{{define "Java.Type.Any"}}Box{{end}}
{{define "Java.Type.Struct"}}{{File.ClassName .}}{{end}}
{{define "Java.Type.Interface"}}{{File.InterfaceName .}}{{end}}
{{define "Java.Type.Pointer"}}{{Call "Java.Type" .Type}}{{end}}
{{define "Java.Type.Array"}}{{Call "Java.Type" .ValueType}}[]{{end}}
{{define "Java.Type.Slice"}}{{Call "Java.Type" .ValueType}}[]{{end}}
{{define "Java.Type.nil"}}void{{end}}

{{define "Java.Import.Struct"}}{{if $p := File.Import .}}import {{$p}};¶{{end}}{{end}}
{{define "Java.Import.Interface"}}{{if $p := File.Import .}}import {{$p}};¶{{end}}{{end}}
{{define "Java.Import.Pointer"}}{{Call "Java.Import" .Type}}{{end}}
{{define "Java.Import.Array"}}{{Call "Java.Import" .ValueType}}{{end}}
{{define "Java.Import.Slice"}}{{Call "Java.Import" .ValueType}}{{end}}
{{define "Java.Import.Any"}}{{if $p := File.Import "any.Box"}}import {{$p}};¶{{end}}{{end}}
{{define "Java.Import"}}{{end}}

{{define "Java.ConstSuffix#int64"}}L{{end}}
{{define "Java.ConstSuffix#uint64"}}L{{end}}
{{define "Java.ConstSuffix#float32"}}f{{end}}
{{define "Java.ConstSuffix#float64"}}d{{end}}
{{define "Java.ConstSuffix"}}{{end}}
